

;
;
;

(define (script-fu-rocky-text_RD image drawable)

(gimp-image-undo-group-start image)

  ; save user settings
  (gimp-context-push)
 
  ; begin
 
  (let*
    (
    (original-1-copy (car (gimp-layer-new-from-visible image image "Rocky Text")))
    (original-1-copy-removed (car (gimp-layer-new-from-visible image image "Cracks Opacity")))	
    (background (car (gimp-layer-new-from-visible image image "Background")))
    (original-1 (car (gimp-layer-new-from-visible image image "Rocky Text Shadow")))	
    )
     
	 ; add the layers
	 
  (gimp-image-add-layer image original-1 1)
  (gimp-image-add-layer image original-1-copy 0)
 
  
  (gimp-drawable-set-visible drawable FALSE) 
  (gimp-drawable-set-visible original-1 FALSE)
  
  ; add background layer
  (gimp-image-add-layer image background 2)  
  (gimp-context-set-foreground '(255 255 255))
  (gimp-image-lower-item-to-bottom image background)
  (gimp-image-add-layer image original-1-copy-removed 0)  
  (gimp-drawable-fill background FILL-FOREGROUND)  
  (gimp-drawable-set-visible background FALSE)  
  
  ; pattern fill and effects
  (gimp-drawable-set-visible original-1-copy-removed FALSE)  
  (gimp-selection-layer-alpha original-1-copy) 
  (gimp-selection-grow image 2)
  (gimp-context-set-pattern "Dried mud")
  (gimp-drawable-fill original-1-copy FILL-PATTERN)

  (gimp-selection-invert image)
  (gimp-edit-clear original-1-copy)
  (gimp-image-raise-item image original-1) 
  (gimp-selection-invert image)  
  (gimp-threshold original-1-copy 170 255)
  
  


  ; pattern fill and effects for original-removed layer
  (gimp-drawable-set-visible original-1-copy-removed TRUE)  
  (gimp-selection-layer-alpha original-1-copy-removed) 
  (gimp-selection-grow image 2)
  (gimp-context-set-pattern "Dried mud")
  (gimp-drawable-fill original-1-copy-removed FILL-PATTERN)

  (gimp-selection-invert image)
  (gimp-edit-clear original-1-copy-removed)
  (gimp-selection-invert image)  
  (gimp-threshold original-1-copy-removed 170 255)
  (gimp-image-raise-item-to-top image original-1-copy-removed)
  (plug-in-oilify RUN-NONINTERACTIVE image original-1-copy-removed 8 0)
  (gimp-invert original-1-copy-removed)  
  (gimp-layer-set-mode original-1-copy-removed LAYER-MODE-SUBTRACT-LEGACY)
  (gimp-layer-set-opacity original-1-copy-removed 70)  
  
  
      (plug-in-lighting RUN-NONINTERACTIVE
                    image            ; input image id
                    original-1-copy-removed          ; input layer id
                    original-1-copy-removed      ; load bumpmap? 0 = DISABLED name = enabled                     
                    0                ; load env map? 0 = DISABLED name = enabled
                    TRUE             ; enable bumpmaping (TRUE/FALSE)
                    FALSE            ; enable env maping (TRUE/FALSE)
                    0                ; Type of mapping (0=linear,1=log, 2=sinusoidal, 3=spherical
                    0                ; type of light src 0 = point
                    '(255 255 255)   ; light src color is white   
                    0.57 -1.27 1.00   ; light position 1 xyz - alt 0.57 -1.27 1.00 or 0.53 2.20 1.00 works
                    -1.00 -1.00 1.00 ; light direction 1 ijk - alt
                    1.00             ; Material ambient intensity (0..1)
                    0.20             ; Material diffuse intensity (0..1)
                    0.50             ; Material diffuse reflectivity (0..1)
                    0.50             ; Material specular reflectivity (0..1)
                    27.0             ; Material highlight (0..->), note: it's expotential
                    TRUE             ; Apply antialiasing (TRUE/FALSE)                                   
                    FALSE            ; Create a new image (TRUE/FALSE)
                    FALSE            ; Make background transparent (TRUE/FALSE)        	
   )
  
  
  
    (plug-in-lighting RUN-NONINTERACTIVE
                    image            ; input image id
                    original-1-copy          ; input layer id
                    original-1-copy      ; load bumpmap? 0 = DISABLED name = enabled                     
                    0                ; load env map? 0 = DISABLED name = enabled
                    TRUE             ; enable bumpmaping (TRUE/FALSE)
                    FALSE            ; enable env maping (TRUE/FALSE)
                    0                ; Type of mapping (0=linear,1=log, 2=sinusoidal, 3=spherical
                    0                ; type of light src 0 = point
                    '(255 255 255)   ; light src color is white   
                    0.57 -1.27 1.00   ; light position 1 xyz - alt 0.57 -1.27 1.00 or 0.53 2.20 1.00 works
                    -1.00 -1.00 1.00 ; light direction 1 ijk - alt
                    1.00             ; Material ambient intensity (0..1)
                    0.20             ; Material diffuse intensity (0..1)
                    0.50             ; Material diffuse reflectivity (0..1)
                    0.50             ; Material specular reflectivity (0..1)
                    27.0             ; Material highlight (0..->), note: it's expotential
                    TRUE             ; Apply antialiasing (TRUE/FALSE)                                   
                    FALSE            ; Create a new image (TRUE/FALSE)
                    FALSE            ; Make background transparent (TRUE/FALSE)        	
   )
  
    (gimp-selection-none image) 
 
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)
	
    (plug-in-gauss RUN-NONINTERACTIVE image original-1 15 15 1)    
    (gimp-drawable-set-visible original-1 TRUE)
    (gimp-drawable-set-visible background TRUE)
    (gimp-context-set-pattern "Dried mud")
    (gimp-drawable-fill background FILL-PATTERN)	

    (plug-in-gauss RUN-NONINTERACTIVE image original-1-copy 4 4 1)  
	(gimp-colorize original-1-copy 37 40 -67)
    (gimp-layer-resize-to-image-size drawable)	
    (gimp-selection-layer-alpha drawable)
	(gimp-selection-grow image 4)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill drawable FILL-FOREGROUND)
	(gimp-layer-set-opacity drawable 75)
    (plug-in-gauss RUN-NONINTERACTIVE image drawable 2 2 1)

    (plug-in-lighting RUN-NONINTERACTIVE
                    image            ; input image id
                    original-1-copy          ; input layer id
                    original-1-copy      ; load bumpmap? 0 = DISABLED name = enabled                     
                    0                ; load env map? 0 = DISABLED name = enabled
                    TRUE             ; enable bumpmaping (TRUE/FALSE)
                    FALSE            ; enable env maping (TRUE/FALSE)
                    0                ; Type of mapping (0=linear,1=log, 2=sinusoidal, 3=spherical
                    0                ; type of light src 0 = point
                    '(255 255 255)   ; light src color is white   
                    0.57 -1.27 1.00   ; light position 1 xyz - alt 0.57 -1.27 1.00 or 0.53 2.20 1.00 works
                    -1.00 -1.00 1.00 ; light direction 1 ijk - alt
                    1.00             ; Material ambient intensity (0..1)
                    0.20             ; Material diffuse intensity (0..1)
                    0.50             ; Material diffuse reflectivity (0..1)
                    0.50             ; Material specular reflectivity (0..1)
                    27.0             ; Material highlight (0..->), note: it's expotential
                    TRUE             ; Apply antialiasing (TRUE/FALSE)                                   
                    FALSE            ; Create a new image (TRUE/FALSE)
                    FALSE            ; Make background transparent (TRUE/FALSE)        	
   )
    (gimp-drawable-set-visible drawable TRUE)	
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)
    (script-fu-add-bevel image original-1-copy 7 FALSE FALSE)	
	(gimp-selection-none image)

  
          ; end  
  ; display new image and return user settings
    (gimp-context-pop)
    (gimp-image-undo-group-end image)
    (gimp-displays-flush image) 
     
  )
)


    ;register menu location and information   

(script-fu-register
"script-fu-rocky-text_RD"
"<Image>/Rod/Alpha to Logo/Rocky Text Effect"
"creates a Rocky Text Effect from a text layer  -  script name: rocky-text_RD.scm"
"Rod Detmer"
"Rod Detmer"
"December 2015"
"RGB* GRAY*"
SF-IMAGE       "The Image" 0
SF-DRAWABLE    "The Drawable" 0

; SF-ADJUSTMENT  "Selection Size (in Pixels)"  '(8 1 32767 1 10 0 SF-SLIDER)
; SF-ADJUSTMENT  "Blur"                            '(17 0.0 9056.0 1 10 0 SF-SLIDER)
; SF-COLOR "color"       '(158 160 32)                                 
)   

